package hwloc;

import hwloc.utils.Tabber;

/**
 * 2012
 * @author Emilio Francesquini <francesquini@gmail.com> 
 * 
 */
public class Core implements MachineHierarchicalNode {

	public static final String type = "Core";
	
	private MachineHierarchicalNode parent;
	private PU[] pus;
	private int osIndex;
	
	public void initialize(int osIndex, MachineHierarchicalNode parentCache, PU[] pus) {		
		parent = parentCache;
		this.pus = pus;
		this.osIndex = osIndex;				
	}
	
	public MachineHierarchicalNode getParent() {
		return parent;
	}
	
	public int getOSIndex() {
		return osIndex;
	}
	
	private void printChildrenStringOn(StringBuffer sb, int tabs) {
		int ntabs = tabs + 1;
		for (PU pu : pus) {
			pu.printOn(sb, ntabs);
			sb.append('\n');
		}
	}
	
	public void printOn(StringBuffer sb, int tabs) {
		Tabber.tab(tabs, sb);
		sb.append("Core #" + getOSIndex());
		sb.append('\n');
		printChildrenStringOn(sb, tabs);
	}


	public MachineHierarchicalNode[] getChildren() {
		return pus;
	}
	
	public boolean isCore() {
		return true;
	}

	public boolean isPU() {
		return false;
	}

	public boolean isCache() {
		return false;
	}
	
}
