package hwloc;

import hwloc.utils.Tabber;

/**
 * 2012
 * @author Emilio Francesquini <francesquini@gmail.com> 
 * 
 */
public class Machine extends Node  {

	public static final String type = "Machine"; 
	
	Node[] numaNodes = null;
	
	public Machine (Socket[] sockets, long memory) {
		this.sockets = sockets;
		this.memory = memory;
	}

//	protected void loadFrom(Object object) {
//		if (!type.equals(object.getType()))
//			throw new UnknownXMLFormatException();
//		List<Object> children = object.getObject();
//		loadChildren(children);
//		loadMemory(object);//after children!!
//	}
//	
//	private void loadChildren(List<Object> children) {		
//		String type = children.get(0).getType();
//		if (Node.type.equals(type)) {
//			loadNUMANodes(children);			
//		} else if (Socket.type.equals(type)) {
//			loadSockets(children);
//		} else
//			throw new UnknownXMLFormatException();		
//	}
//
//	private void loadNUMANodes(List<Object> children) {
//		int i = 0;
//		numaNodes = new Node[children.size()];
//		for (Object child : children)
//			numaNodes[i++] = new Node(this, child);
//	}
//
//	private void loadMemory(Object object) {
//		if (isNUMA())
//			for (Node node : numaNodes)
//				memory += node.getMemory();
//		else
//			memory = new Long(object.getLocalMemory());		
//	}
	
	public boolean isNUMA() {
		return numaNodes != null;
	}

	@Override
	public MachineHierarchicalNode getParent() {
		return null;
	}
	
	public int getSocketCount() {
		if (isNUMA())
			throw new InvalidRequestException();
		return sockets.length;		
	}
	
	public int getCoreCount() {
		int coreCount = 0;
		if (isNUMA())
			for (Node node : numaNodes)
				coreCount += node.getCoreCount();
		else
			coreCount += super.getCoreCount();
		return coreCount;
	}
	
	private String numaString() {
		return "NUMA";
	}
	
	private String smpString() {
		return "SMP - # of Sockets: " + getSocketCount() + " # of Cores " + getCoreCount();
	}
	
	private void printChildrenStringOn(StringBuffer sb, int tabs) {
		MachineHierarchicalNode[] arr = isNUMA() ? numaNodes : sockets;
		for (MachineHierarchicalNode node : arr)
			node.printOn(sb, tabs + 1);
	}
	
	public void printOn(StringBuffer sb, int tabs) {
		Tabber.tab(tabs, sb);
		sb.append("Machine ");
		sb.append(isNUMA() ?  numaString() : smpString());
		sb.append("\nTotal Memory: " + getMemory() + "\n");
		printChildrenStringOn(sb, tabs);
	}
	
	public String print() {
		StringBuffer sb = new StringBuffer();
		printOn(sb, 0);
		return sb.toString();
	}
}
