package hwloc;

import hwloc.utils.Tabber;

/**
 * 2012
 * @author Emilio Francesquini <francesquini@gmail.com> 
 * 
 */
public class PU implements MachineHierarchicalNode {

	public final static String type = "PU";
	private MachineHierarchicalNode parent;
	private int osIndex;
	
	public PU(int osIndex, Core core) {
		this.parent = core;
		this.osIndex = osIndex;
	}

	public MachineHierarchicalNode getParent() {
		return parent;
	}

	public int getOSIndex() {
		return osIndex;
	}
	

	public void printOn(StringBuffer sb, int tabs) {
		Tabber.tab(tabs, sb);
		sb.append(toString());
	}

	public String toString() {
		return "PU #" + getOSIndex();
	}

	public MachineHierarchicalNode[] getChildren() {
		return new MachineHierarchicalNode[0];
	}
	
	public boolean isCore() {
		return false;
	}

	public boolean isPU() {
		return true;
	}

	public boolean isCache() {
		return false;
	}
	
}
